<template>
  <nav class="ui-breadcrumbs" aria-label="Breadcrumb">
    <ol
      class="text-xs font-semibold text-gray-600 md:text-sm md:text-gray-500 lg:text-base xl:text-lg"
    >
      <li
        v-for="(item, index) of items"
        :key="typeof item.to === 'string' ? item.to : `${index}-${item.label}`"
        class="inline-block"
      >
        <component
          :is="item.to !== undefined ? 'router-link' : 'span'"
          :to="item.to"
          :class="{
            'hover:text-violet-700 hover:underline focus:text-violet-700 aria-current-page:text-gray-800 aria-current-page:md:text-gray-700':
              item.to !== undefined,
          }"
          >{{ item.label }}</component
        ><span
          v-if="index < items.length - 1"
          class="mx-2 inline-block select-none text-gray-400 md:text-gray-300"
          aria-hidden="true"
          >/</span
        >
      </li>
    </ol>
  </nav>
</template>

<script lang="ts" setup>
import { PropType } from 'vue'
import { BreadcrumbItem } from '../../propInterfaces'

defineOptions({
  name: 'UiBreadcrumbs',
})

defineProps({
  items: {
    type: Array as PropType<BreadcrumbItem[]>,
    default: () => [],
    validator: (array: BreadcrumbItem[]) => array.every((item) => item.label),
  },
})
</script>
